#ifndef _ASM_PPC_POWERX_SYSCALL_H_
#define _ASM_PPC_POWERX_SYSCALL_H_

/*
 * This file contains the system call numbers.
 */

#define __NR__exit			  1
#define __NR__fork			  2
#define __NR__read			  3
#define __NR__write			  4
#define __NR__open			  5
#define __NR__close			  6
#define __NR__waitpid			  7
#define __NR__creat			  8
#define __NR__link			  9
#define __NR__unlink			 10
#define __NR__execve			 11
#define __NR__chdir			 12
#define __NR__time			 13
#define __NR__mknod			 14
#define __NR__chmod			 15
#define __NR__lchown			 16
#define __NR__break			 17
#define __NR__oldstat			 18
#define __NR__lseek			 19
#define __NR__getpid			 20
#define __NR__mount			 21
#define __NR__umount			 22
#define __NR__setuid			 23
#define __NR__getuid			 24
#define __NR__stime			 25
#define __NR__ptrace			 26
#define __NR__alarm			 27
#define __NR__oldfstat			 28
#define __NR__pause			 29
#define __NR__utime			 30
#define __NR__stty			 31
#define __NR__gtty			 32
#define __NR__access			 33
#define __NR__nice			 34
#define __NR__ftime			 35
#define __NR__sync			 36
#define __NR__kill			 37
#define __NR__rename			 38
#define __NR__mkdir			 39
#define __NR__rmdir			 40
#define __NR__dup			 41
#define __NR__pipe			 42
#define __NR__times			 43
#define __NR__prof			 44
#define __NR__brk			 45
#define __NR__setgid			 46
#define __NR__getgid			 47
#define __NR__signal			 48
#define __NR__geteuid			 49
#define __NR__getegid			 50
#define __NR__acct			 51
#define __NR__umount2			 52
#define __NR__lock			 53
#define __NR__ioctl			 54
#define __NR__fcntl			 55
#define __NR__mpx			 56
#define __NR__setpgid			 57
#define __NR__ulimit			 58
#define __NR__oldolduname		 59
#define __NR__umask			 60
#define __NR__chroot			 61
#define __NR__ustat			 62
#define __NR__dup2			 63
#define __NR__getppid			 64
#define __NR__getpgrp			 65
#define __NR__setsid			 66
#define __NR__sigaction			 67
#define __NR__sgetmask			 68
#define __NR__ssetmask			 69
#define __NR__setreuid			 70
#define __NR__setregid			 71
#define __NR__sigsuspend		 72
#define __NR__sigpending		 73
#define __NR__sethostname		 74
#define __NR__setrlimit			 75
#define __NR__getrlimit			 76
#define __NR__getrusage			 77
#define __NR__gettimeofday		 78
#define __NR__settimeofday		 79
#define __NR__getgroups			 80
#define __NR__setgroups			 81
#define __NR__select			 82
#define __NR__symlink			 83
#define __NR__oldlstat			 84
#define __NR__readlink			 85
#define __NR__uselib			 86
#define __NR__swapon			 87
#define __NR__reboot			 88
#define __NR__readdir			 89
#define __NR__mmap			 90
#define __NR__munmap			 91
#define __NR__truncate			 92
#define __NR__ftruncate			 93
#define __NR__fchmod			 94
#define __NR__fchown			 95
#define __NR__getpriority		 96
#define __NR__setpriority		 97
#define __NR__profil			 98
#define __NR__statfs			 99
#define __NR__fstatfs			100
#define __NR__ioperm			101
#define __NR__socketcall		102
#define __NR__syslog			103
#define __NR__setitimer			104
#define __NR__getitimer			105
#define __NR__stat			106
#define __NR__lstat			107
#define __NR__fstat			108
#define __NR__olduname			109
#define __NR__iopl			110
#define __NR__vhangup			111
#define __NR__idle			112
#define __NR__vm86			113
#define __NR__wait4			114
#define __NR__swapoff			115
#define __NR__sysinfo			116
#define __NR__ipc			117
#define __NR__fsync			118
#define __NR__sigreturn			119
#define __NR__clone			120
#define __NR__setdomainname		121
#define __NR__uname			122
#define __NR__modify_ldt		123
#define __NR__adjtimex			124
#define __NR__mprotect			125
#define __NR__sigprocmask		126
#define __NR__create_module		127
#define __NR__init_module		128
#define __NR__delete_module		129
#define __NR__get_kernel_syms		130
#define __NR__quotactl			131
#define __NR__getpgid			132
#define __NR__fchdir			133
#define __NR__bdflush			134
#define __NR__sysfs			135
#define __NR__personality		136
#define __NR__afs_syscall		137 /* Syscall for Andrew File System */
#define __NR__setfsuid			138
#define __NR__setfsgid			139
#define __NR___llseek			140
#define __NR__getdents			141
#define __NR___newselect		142
#define __NR__flock			143
#define __NR__msync			144
#define __NR__readv			145
#define __NR__writev			146
#define __NR__getsid			147
#define __NR__fdatasync			148
#define __NR___sysctl			149
#define __NR__mlock			150
#define __NR__munlock			151
#define __NR__mlockall			152
#define __NR__munlockall		153
#define __NR__sched_setparam		154
#define __NR__sched_getparam		155
#define __NR__sched_setscheduler	156
#define __NR__sched_getscheduler	157
#define __NR__sched_yield		158
#define __NR__sched_get_priority_max	159
#define __NR__sched_get_priority_min	160
#define __NR__sched_rr_get_interval	161
#define __NR__nanosleep			162
#define __NR__mremap			163
#define __NR__setresuid			164
#define __NR__getresuid			165
#define __NR__query_module		166
#define __NR__poll			167
#define __NR__nfsservctl		168
#define __NR__setresgid			169
#define __NR__getresgid			170
#define __NR__prctl			171
#define __NR__rt_sigreturn		172
#define __NR__rt_sigaction		173
#define __NR__rt_sigprocmask		174
#define __NR__rt_sigpending		175
#define __NR__rt_sigtimedwait		176
#define __NR__rt_sigqueueinfo		177
#define __NR__rt_sigsuspend		178
#define __NR__pread			179
#define __NR__pwrite			180
#define __NR__chown			181
#define __NR__getcwd			182
#define __NR__capget			183
#define __NR__capset			184
#define __NR__sigaltstack		185
#define __NR__sendfile			186
#define __NR__getpmsg			187	/* some people actually want streams */
#define __NR__putpmsg			188	/* some people actually want streams */
#define __NR__vfork			189

#define __NR__isatty			200	/* for ppcsim emulate */
//#define __NR__tell			201	/* for ppcsim emulate */
#define __NR__sbrk			202	/* for ppcsim emulate */

#define __NR(n)	#n


#define __syscall_return(type) \
	return (__sc_err & 0x10000000 ? errno = __sc_ret, __sc_ret = -1 : 0), \
	       (type) __sc_ret

#define __syscall_clobbers \
	"r4", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12"

#define _syscall0(type,name)						\
type name(void)								\
{									\
	unsigned long __sc_ret, __sc_err;				\
	{								\
		register unsigned long __sc_0 __asm__ ("r0");		\
		register unsigned long __sc_3 __asm__ ("r3");		\
									\
		__sc_0 = __NR_##name;					\
		__asm__ __volatile__					\
			("sc\n\t"				\
			 "mfcr %1"				\
			: "=&r" (__sc_3), "=&r" (__sc_0)		\
			: "0"   (__sc_3), "1"   (__sc_0)		\
			: __syscall_clobbers);				\
		__sc_ret = __sc_3;					\
		__sc_err = __sc_0;					\
	}								\
	__syscall_return (type);					\
}

#define _syscall1(type,name,type1,arg1)					\
type name(type1 arg1)							\
{									\
	unsigned long __sc_ret, __sc_err;				\
	{								\
		register unsigned long __sc_0 __asm__ ("r0");		\
		register unsigned long __sc_3 __asm__ ("r3");		\
									\
		__sc_3 = (unsigned long) (arg1);			\
		__sc_0 = __NR_##name;					\
		__asm__ __volatile__					\
			("sc\n\t"				\
			 "mfcr %1"				\
			: "=&r" (__sc_3), "=&r" (__sc_0)		\
			: "0"   (__sc_3), "1"   (__sc_0)		\
			: __syscall_clobbers);				\
		__sc_ret = __sc_3;					\
		__sc_err = __sc_0;					\
	}								\
	__syscall_return (type);					\
}

#define _syscall2(type,name,type1,arg1,type2,arg2)			\
type name(type1 arg1, type2 arg2)					\
{									\
	unsigned long __sc_ret, __sc_err;				\
	{								\
		register unsigned long __sc_0 __asm__ ("r0");		\
		register unsigned long __sc_3 __asm__ ("r3");		\
		register unsigned long __sc_4 __asm__ ("r4");		\
									\
		__sc_3 = (unsigned long) (arg1);			\
		__sc_4 = (unsigned long) (arg2);			\
		__sc_0 = __NR_##name;					\
		__asm__ __volatile__					\
			("sc\n\t"				\
			 "mfcr %1"				\
			: "=&r" (__sc_3), "=&r" (__sc_0)		\
			: "0"   (__sc_3), "1"   (__sc_0),		\
			  "r"   (__sc_4)				\
			: __syscall_clobbers);				\
		__sc_ret = __sc_3;					\
		__sc_err = __sc_0;					\
	}								\
	__syscall_return (type);					\
}

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3)		\
type name(type1 arg1, type2 arg2, type3 arg3)				\
{									\
	unsigned long __sc_ret, __sc_err;				\
	{								\
		register unsigned long __sc_0 __asm__ ("r0");		\
		register unsigned long __sc_3 __asm__ ("r3");		\
		register unsigned long __sc_4 __asm__ ("r4");		\
		register unsigned long __sc_5 __asm__ ("r5");		\
									\
		__sc_3 = (unsigned long) (arg1);			\
		__sc_4 = (unsigned long) (arg2);			\
		__sc_5 = (unsigned long) (arg3);			\
		__sc_0 = __NR_##name;					\
		__asm__ __volatile__					\
			("sc\n\t"				\
			 "mfcr %1"				\
			: "=&r" (__sc_3), "=&r" (__sc_0)		\
			: "0"   (__sc_3), "1"   (__sc_0),		\
			  "r"   (__sc_4),				\
			  "r"   (__sc_5)				\
			: __syscall_clobbers);				\
		__sc_ret = __sc_3;					\
		__sc_err = __sc_0;					\
	}								\
	__syscall_return (type);					\
}

#define _syscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name(type1 arg1, type2 arg2, type3 arg3, type4 arg4)		\
{									\
	unsigned long __sc_ret, __sc_err;				\
	{								\
		register unsigned long __sc_0 __asm__ ("r0");		\
		register unsigned long __sc_3 __asm__ ("r3");		\
		register unsigned long __sc_4 __asm__ ("r4");		\
		register unsigned long __sc_5 __asm__ ("r5");		\
		register unsigned long __sc_6 __asm__ ("r6");		\
									\
		__sc_3 = (unsigned long) (arg1);			\
		__sc_4 = (unsigned long) (arg2);			\
		__sc_5 = (unsigned long) (arg3);			\
		__sc_6 = (unsigned long) (arg4);			\
		__sc_0 = __NR_##name;					\
		__asm__ __volatile__					\
			("sc\n\t"				\
			 "mfcr %1"				\
			: "=&r" (__sc_3), "=&r" (__sc_0)		\
			: "0"   (__sc_3), "1"   (__sc_0),		\
			  "r"   (__sc_4),				\
			  "r"   (__sc_5),				\
			  "r"   (__sc_6)				\
			: __syscall_clobbers);				\
		__sc_ret = __sc_3;					\
		__sc_err = __sc_0;					\
	}								\
	__syscall_return (type);					\
}

#define _syscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4,type5,arg5) \
type name(type1 arg1, type2 arg2, type3 arg3, type4 arg4, type5 arg5)	\
{									\
	unsigned long __sc_ret, __sc_err;				\
	{								\
		register unsigned long __sc_0 __asm__ ("r0");		\
		register unsigned long __sc_3 __asm__ ("r3");		\
		register unsigned long __sc_4 __asm__ ("r4");		\
		register unsigned long __sc_5 __asm__ ("r5");		\
		register unsigned long __sc_6 __asm__ ("r6");		\
		register unsigned long __sc_7 __asm__ ("r7");		\
									\
		__sc_3 = (unsigned long) (arg1);			\
		__sc_4 = (unsigned long) (arg2);			\
		__sc_5 = (unsigned long) (arg3);			\
		__sc_6 = (unsigned long) (arg4);			\
		__sc_7 = (unsigned long) (arg5);			\
		__sc_0 = __NR_##name;					\
		__asm__ __volatile__					\
			("sc\n\t"				\
			 "mfcr %1"				\
			: "=&r" (__sc_3), "=&r" (__sc_0)		\
			: "0"   (__sc_3), "1"   (__sc_0),		\
			  "r"   (__sc_4),				\
			  "r"   (__sc_5),				\
			  "r"   (__sc_6),				\
			  "r"   (__sc_7)				\
			: __syscall_clobbers);				\
		__sc_ret = __sc_3;					\
		__sc_err = __sc_0;					\
	}								\
	__syscall_return (type);					\
}


#ifdef __KERNEL_SYSCALLS__

/*
 * Forking from kernel space will result in the child getting a new,
 * empty kernel stack area.  Thus the child cannot access automatic
 * variables set in the parent unless they are in registers, and the
 * procedure where the fork was done cannot return to its caller in
 * the child.
 */

/*
 * System call prototypes.
 */
/*static inline _syscall0(int,idle)*/
/*static inline _syscall0(int,pause)*/
/*static inline _syscall0(int,sync)*/
/*static inline _syscall0(pid_t,setsid)*/
extern _syscall0(int,_fork)
extern _syscall2(int,_access,const char *,path,int,amode)
extern _syscall1(int,_chdir,const char *,path)
extern _syscall3(int,_chown,const char *,path,uid_t,owner,gid_t,group)
extern _syscall0(gid_t,_getgid)
extern _syscall0(pid_t,_getpid)
extern _syscall2(int,_kill,pid_t,pid,int,sig)
extern _syscall2(int,_link,const char *,src,const char *,dst)
extern _syscall2(int,_mkdir,const char *,path, mode_t,mode)
extern _syscall3(int,_readlink,const char*,linkpath,char *,namebuf,int,buflen)
extern _syscall2(int,_rename,const char *,old,const char *,new)
extern _syscall1(int,_rmdir,const char *,path)
extern _syscall1(int,_setgid,gid_t,gid)
extern _syscall1(int,_setuid,uid_t,uid)
extern _syscall2(int,_symlink,const char *,src,const char *,dst)
extern _syscall1(int,_unlink,const char *,path)
extern _syscall2(int,_getcwd,char *,buff,int,size)

extern _syscall3(int,_write,int,fd,const char *,buf,off_t,count)
extern _syscall3(int,_read,int,fd,char *,buf,off_t,count)
extern _syscall3(off_t,_lseek,int,fd,off_t,offset,int,count)
extern _syscall1(int,_dup,int,fd)
extern _syscall2(int,_dup2,int,fd1,int,fd2)
extern _syscall3(int,_execve,const char *,file,char **,argv,char **,envp)
extern _syscall3(int,_open,const char *,file,int,flag,int,mode)
extern _syscall1(int,_close,int,fd)

/*** spec is not clear syscalls ***/ 
extern _syscall2(int,_fstat,int,fd,int *,stat)
extern _syscall1(int,_isatty,int,fd)
//extern _syscall1(long,_tell,int,fd)
extern _syscall1(int,_sbrk,int,incre)
extern _syscall1(int,_exit,int,exitcode)

/*static inline _syscall3(pid_t,waitpid,pid_t,pid,int *,wait_stat,int,options)*/
/*static inline _syscall1(int,delete_module,const char *,name)*/

extern pid_t wait(int_ * wait_stat) 
{
	return (void*)0 ; /* dummy */
	/*return waitpid(-1,wait_stat,0);*/
}

#endif /* __KERNEL_SYSCALLS__ */

#endif /* _ASM_PPC_POWERX_SYSCALL_H_ */
